-- Credit:
-- Stormcloud-Sentinels

SLASH_RELOADUI1 = "/rl" -- For quicker Reloading.
SlashCmdList.RELOADUI = ReloadUI

--SLASH_FRAMESTK1 = "/fs" -- For quicker access to frame stack

SlashCmdList.FRAMESTK = function()
	LoadAddOn('Blizzard_DebugTools')
	FrameStackTooltip_Toggle()
end

-- to be able to use the left and right arrows in the edit box
-- without rotating your character!

for i = 1, NUM_CHAT_WINDOWS do
	_G["ChatFrame"..i.."EditBox"]:SetAltArrowKeyMode(false)
end
--------------------------------------------------------------------
-- BasicFrameTemplate
-- ThinBorderTemplate

local UIConfigM = CreateFrame("Frame","MSRZ_IgnoreFrame", UIParent,"ThinBorderTemplate");
local UIConfig = CreateFrame("Frame","SRZ_IgnoreFrame", UIParent,"ThinBorderTemplate");
UIConfigM.title = UIConfigM:CreateFontString(nil, "OVERLAY");
UIConfigM.btnOpenAO = CreateFrame("Button", nil, UIConfigM, "GameMenuButtonTemplate");
UIConfig.btnGetParty = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
UIConfig.lblP0 = UIConfig:CreateFontString(nil, "OVERLAY");
UIConfig.lblP1 = UIConfig:CreateFontString(nil, "OVERLAY");
UIConfig.lblP2 = UIConfig:CreateFontString(nil, "OVERLAY");
UIConfig.lblP3 = UIConfig:CreateFontString(nil, "OVERLAY");
UIConfig.lblP4 = UIConfig:CreateFontString(nil, "OVERLAY");
UIConfig.btnIP1 = CreateFrame("Button", "P1", UIConfig, "GameMenuButtonTemplate");
UIConfig.btnIP2 = CreateFrame("Button", "P2", UIConfig, "GameMenuButtonTemplate");
UIConfig.btnIP3 = CreateFrame("Button", "P3", UIConfig, "GameMenuButtonTemplate");
UIConfig.btnIP4 = CreateFrame("Button", "P4", UIConfig, "GameMenuButtonTemplate");
	

	-- Min,Max Button
local btnOA = UIConfigM.btnOpenAO;
	-- GetPartyButton
local btnGP = UIConfig.btnGetParty
	--IgnoreButtons
local piB1 = UIConfig.btnIP1
local piB2 = UIConfig.btnIP2
local piB3 = UIConfig.btnIP3
local piB4 = UIConfig.btnIP4
	--Playerlabels
local pl0 = UIConfig.lblP0
local pl1 = UIConfig.lblP1
local pl2 = UIConfig.lblP2
local pl3 = UIConfig.lblP3
local pl4 = UIConfig.lblP4

-- Main Frame Sizing
local isOpen = false
local aW = 150 -- Addon Width
local oH = 272 -- Addon Maximized
local cH = 24  -- Addon Minimized

local p1 = "nil"
local p2 = "nil"
local p3 = "nil"
local p4 = "nil"

local cnt = 0;

	-- Create an Event EX:
--local frame = CreateFrame("Frame");
UIConfig:RegisterEvent("PLAYER_LOGIN");
--[[ for k, v in pairs(events) do	frame:RegisterEvent(k); end ]]
UIConfig:SetScript("OnEvent", function(self, PLAYER_LOGIN)
	AddonLoaded();
	MaxAddon(isOpen);
end);



-- Register Clicks 
btnOA:RegisterForClicks("AnyUp", "AnyDown");
btnGP:RegisterForClicks("AnyUp", "AnyDown");

piB1:RegisterForClicks("AnyUp", "AnyDown");
piB2:RegisterForClicks("AnyUp", "AnyDown");
piB3:RegisterForClicks("AnyUp", "AnyDown");
piB4:RegisterForClicks("AnyUp", "AnyDown");



-- Make Frame Movable
UIConfigM:EnableMouse(true);
UIConfigM:RegisterForDrag("LeftButton");
UIConfigM:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:SetMovable(true);
		self:StartMoving();
		self.isMoving = true;
	end
end)
UIConfigM:SetScript("OnMouseUp", function(self, button)
	if button == "LeftButton" and self.isMoving then
		self:SetMovable(false);
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end)



	-- Main Frame Size and Properties
-- IgnoreU Frame:
UIConfigM:SetSize(aW,cH); -- Main Frame (Width, Height)
UIConfigM:SetPoint("TOP", UIParent, "TOPLEFT", 300, -20);

UIConfig:SetSize(aW,oH); -- Main Frame (Width, Height)
UIConfig:SetPoint("TOP", UIConfigM, "TOP", 0, 0);



	-- Set Scripts for MouseDown
-- Open/Close Button:
btnOA:SetScript("OnMouseDown", function(self, button)MaxAddon(isOpen);end);
-- Get Party Button:
btnGP:SetScript("OnMouseDown", function(self, button) LoadParty(); end);
-- Ignore Buttons:
piB1:SetScript("OnMouseDown", function(self, button) IgnorePlayer(p1,piB1,pl1); end);
piB2:SetScript("OnMouseDown", function(self, button) IgnorePlayer(p2,pib2,pl2); end);
piB3:SetScript("OnMouseDown", function(self, button)print("ButtonTest");end);
piB4:SetScript("OnMouseDown", function(self, button)print("ButtonTest");end);

function AddonLoaded()
print("SRZ-IgnoreU 1.0 Loaded Successfully!\nReady to IgnoreU!");
end

function MaxAddon(open)
	
	if not open then 	
		UIConfig:Hide();
		UIConfigM:Show();
		isOpen = true;
	else				
		
		UIConfig:Show();
		isOpen = false;
	end
	PlaySound("IGCHARACTERINFOOPEN");
end

	-- Child Frames: Sizes and Properties
-- Addon Title Label: Parent - MainFrame
UIConfigM.title:SetFontObject("GameFontHighlight");
UIConfigM.title:SetPoint("TOPLEFT", UIConfigM, "TOPLEFT", 4, -5);
UIConfigM.title:SetText("IgnoreU 1.0");
UIConfigM.title:SetFont("Fonts\\FRIZQT__.ttf", 14, "OUTLINE");
-- Open/Close Button: Parent - MainFrame
UIConfigM.btnOpenAO:SetPoint("TOPRIGHT", UIConfigM, "TOPRIGHT", -2,-2);
UIConfigM.btnOpenAO:SetSize(50, 20);
UIConfigM.btnOpenAO:SetText("OPEN");
-- Get Party Button:
UIConfig.btnGetParty:SetPoint("TOP", UIConfig, "TOP", 0, -25);
UIConfig.btnGetParty:SetSize(120, 30);
UIConfig.btnGetParty:SetText("Get Party");
UIConfig.btnGetParty:SetNormalFontObject("GameFontNormalLarge");
UIConfig.btnGetParty:SetHighlightFontObject("GameFontHighlightLarge");
-- Player Label:
UIConfig.lblP0:SetFontObject("GameFontHighlight");
UIConfig.lblP0:SetPoint("TOP", UIConfig.btnGetParty, "BOTTOM", 0, -1);
UIConfig.lblP0:SetText("Chief Inspector \n"..UnitName("player"));
UIConfig.lblP0:SetTextColor(0,1,1,1);
UIConfig.lblP0:SetFont("Fonts\\FRIZQT__.ttf", 14, "OUTLINE");
-- Party Member 1 Label:
UIConfig.lblP1:SetFontObject("GameFontHighlight");
UIConfig.lblP1:SetPoint("TOP", UIConfig.lblP0, "BOTTOM", 0, -10);
UIConfig.lblP1:SetText("-PLAYER-");
UIConfig.lblP1:SetFont("Fonts\\FRIZQT__.ttf", 14, "OUTLINE");
-- Party Member 2 Label:
UIConfig.lblP2:SetFontObject("GameFontHighlight");
UIConfig.lblP2:SetPoint("TOP", UIConfig.lblP1, "BOTTOM", 0, -25);
UIConfig.lblP2:SetText("-PLAYER-");
UIConfig.lblP2:SetFont("Fonts\\FRIZQT__.ttf", 14, "OUTLINE");
-- Party Member 3 Label:
UIConfig.lblP3:SetFontObject("GameFontHighlight");
UIConfig.lblP3:SetPoint("TOP", UIConfig.lblP2, "BOTTOM", 0, -25);
UIConfig.lblP3:SetText("-PLAYER-");
UIConfig.lblP3:SetFont("Fonts\\FRIZQT__.ttf", 14, "OUTLINE");
-- Party Member 4 Label:
UIConfig.lblP4:SetFontObject("GameFontHighlight");
UIConfig.lblP4:SetPoint("TOP", UIConfig.lblP3, "BOTTOM", 0, -25);
UIConfig.lblP4:SetText("-PLAYER-");
UIConfig.lblP4:SetFont("Fonts\\FRIZQT__.ttf", 14, "OUTLINE");
	-- Ignore Buttons
-- P1 Button:
UIConfig.btnIP1:SetPoint("TOP", UIConfig.lblP1, "BOTTOM", -1, 0);
UIConfig.btnIP1:SetSize(60, 20);
UIConfig.btnIP1:SetText("Ignore");
-- P2 BUTTON:
UIConfig.btnIP2:SetPoint("TOP", UIConfig.lblP2, "BOTTOM", -1, 0);
UIConfig.btnIP2:SetSize(60, 20);
UIConfig.btnIP2:SetText("Ignore");
-- P3 BUTTON:
UIConfig.btnIP3:SetPoint("TOP", UIConfig.lblP3, "BOTTOM", -1, 0);
UIConfig.btnIP3:SetSize(60, 20);
UIConfig.btnIP3:SetText("Ignore");
-- P4 BUTTON:
UIConfig.btnIP4:SetPoint("TOP", UIConfig.lblP4, "BOTTOM", -1, 0);
UIConfig.btnIP4:SetSize(60, 20);
UIConfig.btnIP4:SetText("Ignore");
-- Functions for Clicks

function LoadParty()
	PlaySound("IGCHARACTERINFOTAB");
	p1 = UnitName("party1");
	p2 = UnitName("party2");
	p3 = UnitName("party3");
	p4 = UnitName("party4");
	
	print("Chief Inspector "..UnitName("player").." is on the case!");
	SetColor("Green",pl1);
	SetColor("Green",pl2);
	SetColor("Green",pl3);
	SetColor("Green",pl4);
	IgnoreCheck(p1,piB1, pl1);
	
	PartyHandler(p1,piB1,pl1);
	PartyHandler(p2,piB2,pl2);
	PartyHandler(p3,piB3,pl3);
	PartyHandler(p4,piB4,pl4);

end
function SetColor(color, label)
if color == "Green" then
label:SetTextColor(0,1,0,1);
elseif color == "Yellow" then
label:SetTextColor(1,1,0,1);
elseif color == "Red" then
label:SetTextColor(1,0,0,1);
elseif color == "LBlue" then
label:SetTextColor(0,1,1,1);
elseif color == "Grey" then
label:SetTextColor(1,1,1,0.4);
end

end
function IgnoreCheck(pN, btn, label)

	if pN ~= nil then
		
		if not IsIgnored(pN) then
			btn:SetText("Ignore");
		else
			btn:SetText("Undo");
			SetColor("Red",label);
		end

	end	

end

function DisableButton(isDisabled, button)

	if isDisabled then
		button:Disable();
	else
		button:Enable();
	end
end

function IgnorePlayer(pName, iB, pL)

	if IsIgnored(pName) then
		DelIgnore(pName);
		iB:SetText("Ignore");
		SetColor("Green",pL);
		PlaySound("MAPPING");
		print("You have Removed "..pName .. " form your Ignore List!");
	else
		AddIgnore(pName);
		iB:SetText("Undo");
		pL:SetTextColor(0,1,0,1);
		SetColor("Red",pL);
		PlaySound("IGQUESTFAILED");
	end
end

-- Handles each Player Label and Buttons
function PartyHandler(pName, iB, pL) -- UnitName, Button, Label
	if pName==nil then
		DisableButton(true, iB);
		pL:SetText("-NoPlayer-");
		SetColor("Grey",pL);
	else
		DisableButton(false, iB);
		pL:SetText(pName);
	end
end









